$changelogs = Get-ChildItem $PSScriptRoot -Filter CHANGELOG.md -Recurse
$to_replace = "## Changelog"

$with_1 = "## Changelog`n`n### Version "

$with_2 = "`n- Added preinit."

foreach($changelog in $changelogs) {
    $manifest_file = Get-ChildItem $changelog.Directory.Parent -Filter manifest.json
    $manifest = Get-Content $manifest_file | ConvertFrom-Json
    $get_version = $manifest.version
    if ($get_version -match '(\d+)\.(\d+)\.(\d+)\.(\d+)') {
        $major_version = $matches[1]
        $minor_version = $matches[2]
        $patch_version = $matches[3]
        $build_version = [int]$matches[4]  # Convert to integer for arithmetic operation
        $build_version++  # Increment the build version
        $new_version = "$major_version.$minor_version.$patch_version.$build_version"
    }

    $with = $with_1 + $new_version + $with_2

    $changelog_content = Get-Content $changelog.FullName

    $changelog_content = $changelog_content -replace $to_replace, $with

    $changelog_content | Set-Content -Path $changelog.FullName


}
